#!/usr/bin/python

import os
from subprocess import *
import sys
import string

if len(sys.argv) < 6:
    sys.stderr.write('Usage: %s tx ty theta_start theta_end theta_step [extra options]\n' % sys.argv[0])
    sys.exit(1)

tx = float(sys.argv[1])
ty = float(sys.argv[2])
start = float(sys.argv[3])
stop = float(sys.argv[4])
step = float(sys.argv[5])
if len(sys.argv)>6:
    extras = sys.argv[6:]
else:
    extras = []

nsteps = int((stop - start) / step)
i = 1
t = start
first = True
while abs(t) < abs(stop):
    sys.stderr.write('**** STEP %d of %d, THETA = %f ****\n' % (i,nsteps+1,t))
    L = Popen(['./grlen.py','%f' % tx, '%f' % ty, '%f' % t] + extras, shell=False, stdout=PIPE).communicate()[0]
    if first:
	print '# Grafting of punctured torus Fuchsian group <A,B> along A'
        print '# Starting point: tr(A) = %f, tr(B) = %f' % (tx,ty)
        if len(extras) > 0:
            print '# options: '+string.join(extras)
	print '# Table of (theta,Lklein1,Lfuchs1,Lklein2,Lfuchs2,...) follows.'
	first = False
    print '%f %s' % (abs(t),L.strip('\n'))
    t = t + step
    i = i + 1

